#NoTrayIcon
Opt("GuiCloseOnESC",0)
$msg = MSGBox(4,"FScrub","You are about to start a hard drive scrub. This may take a fiew minutes depending on your hard drive speed and the amount of space that you have free."&@CRLF&"Continue?")
if $msg = 7 Then Exit
Global $fhandle
Global $write
Global $Ret = 1
if $cmdline[0] >= 1 Then
$File = ""
for $i = 1 to $cmdline[0]
$file &= " "&$Cmdline[$i]
Next
$File = StringTrimLeft($File,1)
Else
$File = "fscrub.fscrub"
EndIf
FileDelete($File)
if @Error Then
Exit
EndIf
$fhandle = FileOpen($File,17)
if @Error Then
Beep(80,80)
Exit
EndIf
$File = StringReplace($File,"/","\")
if not StringInStr($File,"\") Then $File = @Workingdir&"\"&$File
GUICreate("FScrub.",300,200)
$lb = GUICtrlCreateLabel("Initializing...",30,90,240,20)
GUISetState()
for $i = 1 to 131072
$write &= chr(0)&Chr(0)&Chr(0)&Chr(0)&chr(0)&Chr(0)&Chr(0)&Chr(0)
Next
$Drive = StringLeft($File,2)
$Free = DriveSpaceFree($Drive)
if @Error Then
MSGBox(16,"FScrub - Error","Cannot obtain drive information. Exiting.")
Exit
EndIf
$Written = StringLen($Write)/1024/1024
$tstart = TimerInit()
$i = 1
While $ret = 1
$written2 = $written*$i
$Ret = FileWrite($fhandle,$write)
GUICtrlSetData($lb,"Scrubbing drive "&$Drive&". "&Round(($Written2/$Free)*100,1)&"%.")
$i = $i + 1
if GUIGetMSG() = -3 Then ExitProg(0)
Wend
ExitProg(1)
Func ExitProg($status)
FileClose($fhandle)
FileDelete($File)
$tDiff = TimerDiff($TStart)
$Diff = _MS2Human($TDiff)
if $status = 0 Then
MSGBox(16,"Error","The scrubbing process was canceled. You may still have data on your drive that you don't want there. "&@CRLF&"The process took "&$Diff&".")
Else
MSGBox(64,"FScrub","Scrubbing complete."&@CRLF&"The scrubbing process took "&$Diff&".")
EndIf
Exit
EndFunc
Func _MS2Human($Tdiff)
$Min = "minutes"
$Hour = "hours"
$Sec = "seconds"
$Hours = Floor($TDiff/3600000)
if $hours = 1 Then $hour = "hour"
$Mins = Floor(($TDiff-(3600000*$Hours))/60000)
if $Mins = 1 Then $Min = "minute"
$Secs = ($TDiff-(60000*$Mins)-(3600000*$Hours))/1000
if $Secs = 1 Then $Sec = "second"
$Diff = ""
if $Hours > 0 Then $diff &= ", "&$Hours&" "&$hour
if $Mins > 0 Then $diff &= ", "&$Mins&" "&$min
if $Secs > 0 Then $diff &= ", "&$Secs&" "&$sec
$lword = StringTrimLeft($Diff,StringInStr($Diff," ",0,-2))
$Diff = StringTrimLeft($Diff,2)
$Diff = StringRegExpReplace($Diff,", "&$lword&"$"," and "&$lword)
Return $Diff
EndFunc
